/*	
 *	clipgc.c
 *
 *	P/ECEpK[x[WRN^[
 *
 *	uK.Sasada's Home Pagev(http://www.namikilab.tuat.ac.jp/~sasada/)
 *	wPiGC : P/ECE pKx[WRN^[x(http://www.namikilab.tuat.ac.jp/~sasada/prog/pigc.html)
 *	̎QlɂĒ܂B肪Ƃ܂B
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2004 Naoyuki Sawa
 *
 *	* Tue Jul 22 07:00:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 *	* Tue Jul 22 20:04:00 JST 2004 Naoyuki Sawa
 *	- WX^QƂĂ郁ubNĊJĂ܂̂h߁A
 *	  K[x[WRN^[{̂ĂяoO%r0-3X^bNɐςނ悤ɕύX܂B
 */
#include "clip.h"

/****************************************************************************
 *	
 ****************************************************************************/

typedef struct _GC {
	void* (*old_pceHeapAlloc)(unsigned long size);	/* {pceHeapAlloc()ۑB(NULL:) */
	unsigned int sram_top;				/* SRAM擪AhX     */
	unsigned int sram_end;				/* SRAMI[AhX(+1) */
	unsigned int stack_top;				/* X^bN̈擪AhX     */
	unsigned int stack_end;				/* X^bN̈I[AhX(+1) */
	HEAPMEM* heaptop;				/* ŏ̃ubNǗ\̃AhX */
} GC;
static GC _gc;

/* HEAPMEM.ownergBPieceSystemK̒lƏdĂ̓_!! */
#define HMO_NOREF_USER	0x1111	/* QƂHMO_DEFAULT_USER */

static void _gc_run() __attribute__((unused));
static int gc_mark(void* top, void* end);
static void* new_pceHeapAlloc(unsigned long size);

extern unsigned int __START_FRAM_ADDR[];
extern unsigned int __END_FRAM_ADDR[];
extern unsigned int __START_DEFAULT_CODE[];
extern unsigned int __END_DEFAULT_CODE[];
extern unsigned int __START_DEFAULT_DATA[];
extern unsigned int __END_DEFAULT_DATA[];
extern unsigned int __START_DEFAULT_BSS[];
extern unsigned int __END_DEFAULT_BSS[];

/****************************************************************************
 *	
 ****************************************************************************/

void
gc_init()
{
	GC* gc = &_gc;
	//
	const SYSTEMINFO* sysinfo;
	const pceAPPHEAD* apphead;

	/* ܂mɖԂɖ߂܂B */
	gc_free();

	/* SRAM̐擪EI[AhX擾܂B */
	sysinfo = pceSystemGetInfo();
	gc->sram_top = (unsigned int)sysinfo->sram_top;
	gc->sram_end = (unsigned int)sysinfo->sram_end;

	/* X^bN̈ƁAŏ̃ubNǗ\̃AhX擾܂B */
	apphead = (const pceAPPHEAD*)__START_DEFAULT_CODE;
	if(apphead->stack_size) {
		/* * X^bNSRAMɔzuꍇ̃CAEǵAȉ̒ʂłB
		 *
		 *	0000000	+-------------+
		 *		|WORK     |
		 *	0001000	+-------------+	__START_FRAM_ADDR
		 *		|RAM]  |
		 *	0001???	+-------------+	__END_FRAM_ADDR
		 *		|         |
		 *	0002000	+-------------+
		 *
		 *	0100000	+-------------+	__START_DEFAULT_CODE
		 *		|۸ѥ萔 |
		 *	01?????	+-------------+	__END_DEFAULT_CODE == __START_DEFAULT_DATA
		 *		|ϕϐ |
		 *	01?????	+-------------+	__END_DEFAULT_DATA == __START_DEFAULT_BSS
		 *		|ۏϐ|
		 *	01?????	+-------------+	__END_DEFAULT_BSS == apphead->bss_end
		 *		|̈     |
		 *	01?????	+-------------+	(apphead->bss_end + apphead->stack_size) == heaptop
		 *		|˰ߗ̈     |
		 *	0140000	+-------------+
		 */
		gc->stack_top = (unsigned int)apphead->bss_end;
		gc->stack_end = gc->stack_top + apphead->stack_size;
		gc->heaptop = (HEAPMEM*)gc->stack_end;
	} else {
		/* * X^bNRAMɔzuꍇ̃CAEǵAȉ̒ʂłB
		 *
		 *	0000000	+-------------+
		 *		|WORK     |
		 *	0001000	+-------------+	__START_FRAM_ADDR
		 *		|(RAM])|	... ʏ͎g܂B__START_FRAM_ADDR == __END_FRAM_ADDR == 0x1000 łB
		 *	0001???	+-------------+	__END_FRAM_ADDR
		 *		|̈     |
		 *	0002000	+-------------+
		 *
		 *	0100000	+-------------+	__START_DEFAULT_CODE
		 *		|۸ѥ萔 |
		 *	01?????	+-------------+	__END_DEFAULT_CODE == __START_DEFAULT_DATA
		 *		|ϕϐ |
		 *	01?????	+-------------+	__END_DEFAULT_DATA == __START_DEFAULT_BSS
		 *		|ۏϐ|
		 *	01?????	+-------------+	__END_DEFAULT_BSS == apphead->bss_end == heaptop
		 *		|˰ߗ̈     |
		 *	0140000	+-------------+
		 */
		gc->stack_top = (unsigned int)__END_FRAM_ADDR;
		gc->stack_end = 0x2000;
		gc->heaptop = (HEAPMEM*)apphead->bss_end;
	}
	if(gc->heaptop->mark != HEAPMEMMK) DIE();

	/* pceHeapAlloc()tbN܂B(old_pceHeapAlloc!=NULL:) */
	gc->old_pceHeapAlloc = pceVectorSetKs(KSNO_HeapAlloc, new_pceHeapAlloc);
}

void
gc_free()
{
	GC* gc = &_gc;

	/* ĂȂΉ܂B */
	if(!gc->old_pceHeapAlloc) return;

	/* pceHeapAlloc()̃tbN܂B */
	pceVectorSetKs(KSNO_HeapAlloc, gc->old_pceHeapAlloc);

	/* NA܂B(old_pceHeapAlloc==NULL:) */
	memset(gc, 0, sizeof(GC));
}

/* void gc_run() */
asm("
	.code
	.global gc_run
gc_run:
	; Ăяo֐ALȃubNւ̃|C^%r0-3ɕێĂ\܂B
	; K[x[WRN^[̓WX^̃ubNQƂȂ̂ŁA
	; ̂܂܂ł́AWX^QƂĂ郁ubNĊJĂ܂\܂B
	; ̖邽߁A%r0-3X^bNɐςłAK[x[WRN^[{̂ĂяoƂɂ܂B
	pushn %r3
	call _gc_run
	popn %r3
	ret
");

static void
_gc_run()
{
	GC* gc = &_gc;
	//
	int retval;
	HEAPMEM* phm;

	/* ɌĂł͂܂B */
	if(!gc->old_pceHeapAlloc) DIE();

	/* 蓖čςUSERubNAɖQƂƂĂ܂B */
	for(phm = gc->heaptop; phm; phm = phm->chain) {
		if(phm->mark != HEAPMEMMK) DIE();
		if(phm->owner == HMO_NOREF_USER) DIE(); /* PieceSystemK̒lƏd!? */
		if(phm->owner == HMO_DEFAULT_USER) phm->owner = HMO_NOREF_USER;
	}

	/* QƃubN̂AX^bN̈orf[^̈悩QƂĂ̂AHMO_DEFAULT_USERɖ߂܂B */
	gc_mark((void*)gc->stack_top, (void*)gc->stack_end);
	gc_mark(__START_DEFAULT_DATA, __END_DEFAULT_DATA);
	gc_mark(__START_DEFAULT_BSS, __END_DEFAULT_BSS);

	/* QƃubN̂AorQƃubNȊOQƂĂ̂AHMO_DEFAULT_USERɖ߂܂B */
	do {
		for(phm = gc->heaptop; phm; phm = phm->chain) {
			if(phm->mark != HEAPMEMMK) DIE();
			if(phm->owner && phm->owner != HMO_NOREF_USER) {
				retval = gc_mark(phm + 1/*Kv!!*/, phm->chain);
				if(retval) break; /* VQƂǉꂽAxŏ */
			}
		}
	} while(phm); /* breakŔꍇAxŏ */

	/* QƂ̂܂܎cubNJ܂B */
	do {
		for(phm = gc->heaptop; phm; phm = phm->chain) {
			if(phm->mark != HEAPMEMMK) DIE();
			if(phm->owner == HMO_NOREF_USER) {
				retval = pceHeapFree(phm + 1/*Kv!!*/);
				if(retval != 0) DIE();
				break; /* `FCω̂ŁAxŏ */
			}
		}
	} while(phm); /* breakŔꍇAxŏ */
}

/* w͈͂̑S[h𑖍āAQƃubNւ̐VQƂo܂B
 * VQƂoA}[N(HMO_DEFAULT_USER)āAJEgAbv܂B
 * ɎQƃ}[NĂ郁ubNւ̎QƂ́AJEgAbv܂B
 */
static int
gc_mark(void* top, void* end)
{
	int count = 0;
	GC* gc = &_gc;
	//
	unsigned int* pos;
	unsigned int addr;
	HEAPMEM* phm;

	for(pos = (unsigned int*)top; pos < (unsigned int*)end; pos++) {
		addr = *pos - sizeof(HEAPMEM)/*Kv!!*/;
		if(!(addr & 3) && (addr >= gc->sram_top) && (addr < gc->sram_end)) {
			for(phm = gc->heaptop; phm; phm = phm->chain) {
				if(phm->mark != HEAPMEMMK) DIE();
				if(phm == (HEAPMEM*)addr) {
					if(phm->owner == HMO_NOREF_USER) {
						phm->owner = HMO_DEFAULT_USER;
						count++;
					}
					break;
				}
			}
		}
	}

	return count;
}

static void*
new_pceHeapAlloc(unsigned long size)
{
	GC* gc = &_gc;
	//
	void* ptr;

	ptr = gc->old_pceHeapAlloc(size); /* 1st try */
	if(!ptr) {
		gc_run();
		ptr = gc->old_pceHeapAlloc(size); /* 2nd try */
		if(!ptr) DIE();
	}

	return ptr;
}

